summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorSaumit Dinesan <79687674+justsaumit@users.noreply.github.com>2022-02-22 09:34:09 +0530
committerGitHub <noreply@github.com>2022-02-22 09:34:09 +0530
commitbbccd019fd7e1226eea547083f086226692659de (patch)
treeb53848b4be659b33ce0f310244759a74cbe9e1c8
parente5cbb362da9af7e99949855192b6bd625952aca0 (diff)
Add files via upload
-rw-r--r--external_pipe-scripts/st-copyout16
-rw-r--r--external_pipe-scripts/st-urlhandler19
2 files changed, 35 insertions, 0 deletions
diff --git a/external_pipe-scripts/st-copyout b/external_pipe-scripts/st-copyout
new file mode 100644
index 0000000..e7be21e
--- /dev/null
+++ b/external_pipe-scripts/st-copyout
@@ -0,0 +1,16 @@
+#!/bin/sh
+# Using external pipe with st, give a dmenu prompt of recent commands,
+# allowing the user to copy the output of one.
+# xclip required for this script.
+# By Jaywalker and Luke
+## figure how to not print ps1 without having to clear terminal
+## have only one command in active window and then piping into awk
+## to skip the first line
+tmpfile=$(mktemp /tmp/st-cmd-output.XXXXXX)
+trap 'rm "$tmpfile"' 0 1 15
+sed -n "w $tmpfile"
+sed -i 's/\x0//g' "$tmpfile"
+ps1="$(grep "\S" "$tmpfile" | tail -n 1 | sed 's/^\s*//' | cut -d' ' -f1)"
+chosen="$(grep -F "$ps1" "$tmpfile" | sed '$ d' | tac | dmenu -p "Copy which command's output?" -i -l 10 | sed 's/[^^]/[&]/g; s/\^/\\^/g')"
+eps1="$(echo "$ps1" | sed 's/[^^]/[&]/g; s/\^/\\^/g')"
+awk "/^$chosen$/{p=1;print;next} p&&/$eps1/{p=0};p" "$tmpfile" | awk 'NR!=1' |xclip -selection clipboard
diff --git a/external_pipe-scripts/st-urlhandler b/external_pipe-scripts/st-urlhandler
new file mode 100644
index 0000000..e2a62f4
--- /dev/null
+++ b/external_pipe-scripts/st-urlhandler
@@ -0,0 +1,19 @@
+#!/bin/sh
+
+urlregex="(((http|https|gopher|gemini|ftp|ftps|git)://|www\\.)[a-zA-Z0-9.]*[:]?[a-zA-Z0-9./@$&%?$\#=_~-]*)|((magnet:\\?xt=urn:btih:)[a-zA-Z0-9]*)"
+
+urls="$(sed 's/.*│//g' | tr -d '\n' | # First remove linebreaks and mutt sidebars:
+ grep -aEo "$urlregex" | # grep only urls as defined above.
+ uniq | # Ignore neighboring duplicates.
+ sed "s/\(\.\|,\|;\|\!\\|\?\)$//;
+ s/^www./http:\/\/www\./")" # xdg-open will not detect url without http
+
+[ -z "$urls" ] && exit 1
+
+while getopts "hoc" o; do case "${o}" in
+ h) printf "Optional arguments for custom use:\\n -c: copy\\n -o: xdg-open\\n -h: Show this message\\n" && exit 1 ;;
+ o) chosen="$(echo "$urls" | dmenu -i -p 'Follow which url?' -l 10)"
+ setsid xdg-open "$chosen" >/dev/null 2>&1 & ;;
+ c) echo "$urls" | dmenu -i -p 'Copy which url?' -l 10 | tr -d '\n' | xclip -selection clipboard ;;
+ *) printf "Invalid option: -%s\\n" "$OPTARG" && exit 1 ;;
+esac done